﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Data;
using Telerik.WinControls.UI;

namespace _1050383
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        BindingList<Data> data = new BindingList<Data>();
        Telerik.WinControls.Enumerations.ToggleState oldState = Telerik.WinControls.Enumerations.ToggleState.Indeterminate;
        public RadForm1()
        {
            InitializeComponent();
            for (int i = 0; i < 100; i++)
            {
                data.Add(new Data() { Text = "Row" + i, Checked = i % 2 == 0 });
            }
            radGridView1.CreateCell += RadGridView1_CreateCell;
            radGridView1.DataSource = data;
            radGridView1.EnableFiltering = true;
          
           
            new Telerik.WinControls.RadControlSpy.RadControlSpyForm().Show();
        }

        private void RadGridView1_CreateCell(object sender, GridViewCreateCellEventArgs e)
        {
            if (e.CellType == typeof(GridFilterCheckBoxCellElement))
            {
                var cell = new MyFiltercell((GridViewDataColumn)e.Column, e.Row);
                cell.OnToggle += Cell_OnToggle;
                cell.SyncState(oldState);
                e.CellElement = cell;
            }
        }

        private void Cell_OnToggle(object source, StateChangedEventArgs e)
        {
            var grid = radGridView1;
            oldState = e.ToggleState;

            if (e.ToggleState == Telerik.WinControls.Enumerations.ToggleState.On)
            {
               
                var newdata = from i in data
                              where i.Checked == true
                              select i;

                grid.DataSource = newdata.ToList();

            }
            else if (e.ToggleState == Telerik.WinControls.Enumerations.ToggleState.Off)
            {
                
                var newdata = from i in data
                              where i.Checked == false
                              select i;

                grid.DataSource = newdata.ToList();
            }
            else
            {
                grid.DataSource = data;
            }
        }
    }
    public delegate void MyEventHandler(object source, StateChangedEventArgs e);
    class MyFiltercell : GridFilterCheckBoxCellElement
    {
       
        public MyFiltercell(GridViewDataColumn column, GridRowElement row) : base(column, row)
        {
           
        }
        RadCheckBoxElement checkBox = new RadCheckBoxElement();
        protected override void CreateChildElements()
        {
            base.CreateChildElements();
            var editor = this.Editor as RadCheckBoxEditor;
            editor.EditorElement.Visibility = Telerik.WinControls.ElementVisibility.Collapsed;
            this.Children.Remove(editor.EditorElement);

            this.Children.Add(checkBox);
            checkBox.IsThreeState = true;
            checkBox.ShouldHandleMouseInput = true;
            checkBox.NotifyParentOnMouseInput = false;
            checkBox.ToggleStateChanged += CheckBox_ToggleStateChanged;
        }

        public event MyEventHandler OnToggle;
        public void SyncState(Telerik.WinControls.Enumerations.ToggleState state)
        {
            checkBox.ToggleStateChanged -= CheckBox_ToggleStateChanged;
            checkBox.ToggleState = state;
            checkBox.ToggleStateChanged += CheckBox_ToggleStateChanged;
        }
        private void CheckBox_ToggleStateChanged(object sender, StateChangedEventArgs args)
        {
            if(OnToggle != null)
            {
                OnToggle(this, args);
            }
        }
        protected override SizeF ArrangeOverride(SizeF finalSize)
        {
            var result = base.ArrangeOverride(finalSize);
            checkBox.Arrange(new RectangleF(finalSize.Width / 2 - checkBox.DesiredSize.Width, 0, finalSize.Width, finalSize.Height));

            return result;
        }
    }
    class Data
    {
        public string Text { get; set; }
        public bool Checked { get; set; }
    }
}
